'use strict';
module.exports = async (arg) => {
    const len = arg.length;
    const logs = require('../utils/logs');
    const {conf} = require('../utils/path');
    const {isFile,readFile,addFile} = require('../utils/fs');
    if(isFile(conf)){
        if(len!==0&&len!==2){
            logs.r('Param Error');
            logs.g('fk2 server');
            logs.g('fk2 server [hostName] [port]');
            return
        }
        const {dkey,ekey} = require('rrid');
        let data = await readFile(conf);
        data = JSON.parse(dkey(data));
        if(len==0&&!data.bind){
            logs.r('This node has not been started before');
            logs.g('fk2 server [hostName] [port]');
            return;
        }
        if(len==2){
            const {isPort,isStr} = require('../utils/utils');
            if(!isStr(arg[0])){
                logs.r('The HostName Error');
                return;
            }
            if(!isPort(arg[1])){
                logs.r('The Port Error');
                return;
            }
            data.host = arg[0];
            data.port = arg[1];
        }
        // 打开节点服务
        const freePort = require('../utils/freePort');
        if(await freePort(data.port,data.host)) {
            require('../service/cluster')(data);
            data.startTime = new Date().getTime();
            await addFile(conf,ekey(JSON.stringify(data)));
        }else{
            logs.r('Address already in use '+data.host+':'+data.port)
        }
    }else{
        logs.r('Not initialized yet');
        logs.g('fk2 init [dir]');
    }
}