module.exports = (port,host) => {
    return new Promise((resolve) => {
        const net = require('net');
        host = host || 'localhost';
        const server = net.createServer(() => { });
        server.listen(port, host, () => {
            server.close();
            resolve(true);
        });
        server.on('error', (err) => {
            if (err.code === 'EADDRINUSE') {
                resolve(false); // 端口已被占用
            } else {
                resolve(true); // 其他错误
            }
        });
    })
}